#!/usr/bin/env python
# Copyright 2006, CRIM, Revolution Linux Inc.
#
# $Id: utils.py 2071 2006-08-11 02:04:13Z francis $
#
# Authors : Francis Giraldeau <francis.giraldeau@revolutionlinux.com>
#
# This file is part of the MILLE-XTERM project.
#
#		http://www.revolutionlinux.com/mille-xterm/
#		http://www.mille.ca/
#
# This program is covered by the GNU General Public License.
# See the COPYING file in the top-level MILLE-XTERM directory.
#
# -------------------------------------------------------------------------

import sys, os
from subprocess import *

debug = False

def execute_cmd(cmd):
	failed = True
	try:
		if debug: print cmd
		process = Popen(cmd)
		retcode = process.wait()
		if retcode < 0:
			print >>sys.stderr, "Command was terminated by signal ", -retcode
		elif retcode > 0:
			print >>sys.stderr, "Command exited with error : %s" % retcode
		else:
			print >>sys.stderr, "Command exited normaly ", retcode
			failed = False
	except OSError, e:
		print >>sys.stderr, "Execution failed:", e
		sys.exit(1)
	except KeyboardInterrupt, e:
		print >>sys.stderr, "Keybord interrupt, bye."
		sys.exit(1)

	if failed:
		print "An error occured with the command  "

def wise_mkdir(dir):
	if dir is "":
		if debug : print "Empty directory"
		return
	if not os.path.isdir(dir):
		if not os.path.exists(dir):
			print "Creating the directory ", dir
			try:
				os.makedirs(dir)
			except:
				print "Error : ", str(sys.exc_value) 
				sys.exit(1)
