#!/bin/bash
#
# Copyright 2006, CRIM, Revolution Linux Inc.
#
# $Id: setupsshkeys.sh 1680 2006-04-01 03:21:20Z pgauvin $
#
# Authors : Gabriel Lefebvre <lefebvre.gabriel@gmail.com>
#
# This file is part of the MILLE-XTERM project.
#
#       http://www.revolutionlinux.com/mille-xterm/
#       http://www.mille.ca/
#
# This program is covered by the GNU General Public License.
# See the COPYING file in the top-level MILLE-XTERM directory.
#
# -------------------------------------------------------------------------
#
# Grant passwordless ssh access to the user by putting his public key into root's 'authorized_keys[2]' file,
# but make sure there is no more than one user key in 'authorized_keys'
#

PUBKEY=$@
WRKDIR=/root/.ssh

#
# Save content into authorized_keys.session file
#
echo $PUBKEY > $WRKDIR/authorized_keys.session

#
# Backup existing authorized_keys to .orig files
#
for AUTHORIZED_KEY_FILE in "authorized_keys" "authorized_keys2"; do
	if [ ! -f $WRKDIR/$AUTHORIZED_KEY_FILE.orig ]; then
		if [ ! -f $WRKDIR/$AUTHORIZED_KEY_FILE ]; then
			cat /dev/null > $WRKDIR/$AUTHORIZED_KEY_FILE.orig
		else
			cp $WRKDIR/$AUTHORIZED_KEY_FILE $WRKDIR/$AUTHORIZED_KEY_FILE.orig
		fi
	fi
done


#
# Add $PUBKEY to the authorized_keys files
#
for AUTHORIZED_KEY_FILE in "authorized_keys" "authorized_keys2"; do
	cat $WRKDIR/$AUTHORIZED_KEY_FILE.orig > $WRKDIR/$AUTHORIZED_KEY_FILE
	cat $WRKDIR/authorized_keys.session >> $WRKDIR/$AUTHORIZED_KEY_FILE
	if [ -f $WRKDIR/authorized_keys.cron ]; then
		cat $WRKDIR/authorized_keys.cron >> $WRKDIR/$AUTHORIZED_KEY_FILE
	fi 
done

